<?php

/**
 * inf_ven_consol_cliente actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class res_anul_ven_detaActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 0;
              }
              } else {
              $estado = 0;
              } */

            /*
             * Variables opcionales
             */
            
            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.fecha_anu, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (

Select 

2 as orden,
id_punto_venta,
'TOTAL: '||PV as PV,
null as factura,
null as fecha,
sum(NVL(VALOR_FACTURA,0)) AS VALOR_FACTURA,
sum(NVL(VALOR_IVA,0)) AS VALOR_IVA,
sum(NVL(TOTAL,0)) AS TOTAL

from(

select tab0.*

from (

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.nombre AS PV,
tab1.sec_factura AS FACTURA,
to_char(tab1.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS VALOR_IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado = 0

UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.nombre AS PV,
tab4.sec_debito AS FACTURA,
to_char(tab4.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 0
)tab0

where tab0.id_punto_venta IS NOT NULL 
$wherePuntoVenta
    
)GROUP BY id_punto_venta, PV

UNION

select 
1 AS orden,
tab0.id_punto_venta as id_punto_venta,
tab0.PV AS pv,
tab0.factura AS factura,
tab0.fecha AS fecha,
tab0.valor_factura AS valor_factura,
tab0.valor_iva AS valor_iva,
tab0.total AS valor_total

from (

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.nombre AS PV,
tab1.sec_factura AS FACTURA,
to_char(tab1.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS VALOR_IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado = 0

UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.nombre AS PV,
tab4.sec_debito AS FACTURA,
to_char(tab4.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 0
)tab0

where tab0.id_punto_venta IS NOT NULL 
$wherePuntoVenta

order by id_punto_venta,orden
)
)

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];




            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

Select 

2 as orden,
id_punto_venta,
'TOTAL: '||PV as PV,
null as factura,
null as fecha,
sum(NVL(VALOR_FACTURA,0)) AS VALOR_FACTURA,
sum(NVL(VALOR_IVA,0)) AS VALOR_IVA,
sum(NVL(TOTAL,0)) AS TOTAL

from(

select tab0.*

from (

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.nombre AS PV,
tab1.sec_factura AS FACTURA,
to_char(tab1.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS VALOR_IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado = 0

UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.nombre AS PV,
tab4.sec_debito AS FACTURA,
to_char(tab4.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 0
)tab0

where tab0.id_punto_venta IS NOT NULL 
$wherePuntoVenta
    
)GROUP BY id_punto_venta, PV

UNION

select 
1 AS orden,
tab0.id_punto_venta as id_punto_venta,
tab0.PV AS pv,
tab0.factura AS factura,
tab0.fecha AS fecha,
tab0.valor_factura AS valor_factura,
tab0.valor_iva AS valor_iva,
tab0.total AS valor_total

from (

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.nombre AS PV,
tab1.sec_factura AS FACTURA,
to_char(tab1.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS VALOR_IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado = 0

UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.nombre AS PV,
tab4.sec_debito AS FACTURA,
to_char(tab4.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 0
)tab0

where tab0.id_punto_venta IS NOT NULL 
$wherePuntoVenta

order by id_punto_venta,orden
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;



            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow =  $this->startRow + count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 0;
              }
              } else {
              $estado = 0;
              } */

            /*
             * Variables opcionales
             */
            
            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT 
    
count(*) as id_punto_venta, 
'TOTALES' as pv,
SUM(NVL(valor_factura,0)) as valor_factura, 
SUM(NVL(valor_iva,0)) as valor_iva, 
SUM(NVL(valor_factura,0)) + SUM(NVL(valor_iva,0)) as total

FROM (


select tab0.*

from (

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.nombre AS PV,
tab1.sec_factura AS FACTURA,
to_char(tab1.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS VALOR_IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado = 0

UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.nombre AS PV,
tab4.sec_debito AS FACTURA,
to_char(tab4.fecha_anu,'dd-mm-yyyy') AS FECHA,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_anu, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 0
)tab0

where tab0.id_punto_venta IS NOT NULL 
$wherePuntoVenta
    
)
EOD;
    


            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
